//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
//  Copyright Syncfusion Inc. 2001 - 2003. All rights reserved. Use of this code is subject to the terms of our 
//  license. A copy of the current license can be obtained at any time by e-mailing licensing@syncfusion.com. 
//  Re-distribution in any form is strictly prohibited. Any infringement will be prosecuted under applicable laws. 
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
 
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace CellCommentTips
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private ExcelTip.CommentMouseController commentMouseController1;
		private ExcelTip.CommentMouseController commentMouseController2;
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
		private System.Windows.Forms.Label label1;
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
			this.label1 = new System.Windows.Forms.Label();
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridControl1
			// 
			this.gridControl1.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.gridControl1.Location = new System.Drawing.Point(16, 48);
			this.gridControl1.Name = "gridControl1";
			this.gridControl1.Size = new System.Drawing.Size(504, 208);
			this.gridControl1.TabIndex = 3;
			this.gridControl1.Text = "gridControl1";
			// 
			// label1
			// 
			this.label1.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.label1.Location = new System.Drawing.Point(48, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(472, 23);
			this.label1.TabIndex = 1;
			this.label1.Text = "Right-click a cell to add, remove or edit a comment.  Or, left-click an existing " +
				"comment corner.";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(16, 280);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(504, 184);
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 2;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(552, 478);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.gridDataBoundGrid1,
																		  this.label1,
																		  this.gridControl1});
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			this.gridDataBoundGrid1.DataSource = GetTable();
			//create the Comment mousecontroller.
			this.commentMouseController2 = new ExcelTip.CommentMouseController(this.gridDataBoundGrid1);
			this.commentMouseController1 = new ExcelTip.CommentMouseController(gridControl1);
			//allow context menu to edit/add comments
			this.commentMouseController1.ContextMenuEnabled = true;
			this.commentMouseController2.ContextMenuEnabled = true;
			//register the controller
			gridControl1.MouseControllerDispatcher.Add(commentMouseController1);
			this.gridDataBoundGrid1.MouseControllerDispatcher.Add(commentMouseController2);
			this.gridDataBoundGrid1.Model.QueryCellInfo += new GridQueryCellInfoEventHandler(this.gridDataBoundGrid1_QueryCellInfo);
			this.gridDataBoundGrid1.Model.SaveCellInfo += new GridSaveCellInfoEventHandler(this.gridDataBoundGrid1_SaveCellInfo);
			
			//gridControl1.ExcelLikeCurrentCell = true;
			//gridControl1.ExcelLikeSelectionFrame = true;

			//set the comment using custom style property, ExcelTipText
			ExcelTip.GridExcelTipStyleProperties style1 =  new ExcelTip.GridExcelTipStyleProperties(this.gridDataBoundGrid1[2,2]);
			style1.ExcelTipText = "Comment for DataBoundGrid";

			ExcelTip.GridExcelTipStyleProperties style =  new ExcelTip.GridExcelTipStyleProperties(gridControl1[2, 2]);
			style.ExcelTipText = "Comment for cell 2,2.";

			style =  new ExcelTip.GridExcelTipStyleProperties(gridControl1[4, 3]);
			style.ExcelTipText = "Comment for cell 4,3.";

			style =  new ExcelTip.GridExcelTipStyleProperties(gridControl1[4, 4]);
			style.ExcelTipText = "Comment for cell 4,4" + Environment.NewLine + "holds multiple lines." 
				+ Environment.NewLine + "Here is the third one."
				+ Environment.NewLine + "Here is the fourth one."
				+ Environment.NewLine + "Here is the fifth one."
				+ Environment.NewLine + "Here is the six one."
				+ Environment.NewLine + "Here is the seventh one.";

			int yyy = this.excelTipsCache.Count;

			

		}
		private DataTable GetTable()
		{
			DataTable dt = new DataTable("MyTable");

			int nCols = 4;
			int nRows = 10;

			for(int i = 0; i < nCols; i++)
				dt.Columns.Add(new DataColumn(string.Format("Col{0}", i)));

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; j++)
					dr[j] = string.Format("row{0} col{1}", i, j);
				dt.Rows.Add(dr);
			}
			return dt;
		}

		private Hashtable excelTipsCache = new Hashtable();

		private object GetHashCode(int row, int col)
		{	//return some unqique value
			return 10000 * row + col;
		}

		private void gridDataBoundGrid1_QueryCellInfo(object sender, Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventArgs e)
		{
			GridStyleInfo style = this.excelTipsCache[GetHashCode(e.RowIndex, e.ColIndex)] as GridStyleInfo;
			if(style != null)
			{
				//ExcelTip.GridExcelTipStyleProperties excelStyle =  new ExcelTip.GridExcelTipStyleProperties(style);
				//excelStyle.ExcelTipText = "Comment for cell 2,2." ;
				//e.Handled = true;
				e.Style.ModifyStyle(style, Syncfusion.Styles.StyleModifyType.Override);
			}
		}

		private void gridDataBoundGrid1_SaveCellInfo(object sender, Syncfusion.Windows.Forms.Grid.GridSaveCellInfoEventArgs e)
		{
			if(e.RowIndex > 0 && e.ColIndex > 0)
			{
				ExcelTip.GridExcelTipStyleProperties excelStyle =  new ExcelTip.GridExcelTipStyleProperties(e.Style);
				if(excelStyle.ExcelTipText.Length > 0)
				{
					object key = GetHashCode(e.RowIndex, e.ColIndex);
					if(this.excelTipsCache.ContainsKey(key))
						this.excelTipsCache[key] = e.Style;
					else
						this.excelTipsCache.Add(key, e.Style);
				}
			}
		}

	}
}
